"{ Package: 'cvut:stx/goodies/libsvn' }"

"{ NameSpace: SVN }"

Object subclass:#RepositoryManager
	instanceVariableNames:'configurations repositories workingCopyBase'
	classVariableNames:'Current'
	poolDictionaries:''
	category:'SVN-Core'
!


!RepositoryManager class methodsFor:'instance creation'!

new
    ^ self basicNew initialize.

    "Created: / 16-03-2008 / 11:53:21 / janfrog"
! !

!RepositoryManager class methodsFor:'accessing'!

current

    Current ifNil:
        [Current := self new].
    ^Current

    "Created: / 16-03-2008 / 11:52:11 / janfrog"
    "Modified: / 07-06-2008 / 22:23:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

disable

    self enabled: false

    "Created: / 20-04-2008 / 09:19:00 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 07-06-2008 / 22:30:10 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

enable

    self enabled: true

    "Created: / 20-04-2008 / 09:21:29 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 07-06-2008 / 22:30:18 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

enabled

    ^UserPreferences current svnEnabled

    "Created: / 20-04-2008 / 09:27:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 03-10-2008 / 11:28:42 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

enabled: aBoolean

    UserPreferences current svnEnabled: aBoolean.
    self changed:#enabled

    "Created: / 20-04-2008 / 09:18:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 03-10-2008 / 11:28:55 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

hasRepositoryForPackage: package

    self enabled ifFalse:[^false].
    ^self current hasRepositoryForPackage: package

    "Created: / 19-04-2008 / 10:04:39 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 07-06-2008 / 22:28:15 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

repositoryForPackage: package

    ^self repositoryForPackage: package onlyFromCache: false

    "Created: / 25-05-2009 / 19:48:22 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 16-08-2009 / 18:42:45 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

repositoryForPackage: package onlyFromCache: aBoolean

    self enabled ifFalse:[^nil].
    ^self current repositoryForPackage: package onlyFromCache: aBoolean

    "Created: / 16-08-2009 / 18:41:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

repositoryUrlForPackage: package

    self enabled ifFalse:[^nil].
    ^self current repositoryUrlForPackage: package

    "Created: / 25-05-2009 / 19:48:22 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reset

    self current reset.

    "Created: / 31-03-2008 / 10:55:10 / janfrog"
    "Modified: / 20-03-2009 / 10:44:31 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

workingCopyForPackage: package

    | repo |
    ^(repo := self repositoryForPackage: package)
        ifNil:[nil]
        ifNotNil:[repo workingCopy]

    "Created: / 13-08-2009 / 15:08:38 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!RepositoryManager methodsFor:'accessing'!

configurationForPackage: package

    ^self configurations
        detect: [:cfg|cfg matchesPackage: package]
        ifNone: [nil]

    "Created: / 03-10-2008 / 15:38:37 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

configurations
    configurations ifNil:
        [configurations := UserPreferences current svnConfigurations].
    ^configurations

    "Created: / 26-05-2008 / 10:47:34 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 03-10-2008 / 13:11:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

configurations: anObject
        configurations := anObject

    "Created: / 03-10-2008 / 13:10:03 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

repositoryForPackage:package 

    ^self repositoryForPackage:package onlyFromCache: false

    "Modified: / 16-08-2009 / 18:44:11 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

repositoryForPackage:package onlyFromCache: onlyFromCache 
    | repo cfg |

    repo := repositories at:package ifAbsent:[ nil ].
    onlyFromCache ifTrue:[^repo].
    repo ifNotNil:[ ^ repo ].
    cfg := self configurationForPackage: package.
    cfg ifNotNil:
        [repo := (Repository new)
                    manager: self;
                    url:(cfg urlForPackage:package);
                    package:package].
    repo ifNil:[ ^ nil ].
    repo exists ifTrue:[
        repo workingCopy:(self workingCopyForPackage:package)
    ] ifFalse:[
        repo := nil
    ].
    repositories at:package put:repo.
    ^ repo

    "Modified: / 01-04-2008 / 19:08:35 / janfrog"
    "Created: / 16-08-2009 / 18:43:39 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 19-08-2009 / 13:07:45 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

repositoryUrlForPackage:package 
    | repo cfg |

    repo := repositories at:package ifAbsent:[ nil ].
    repo ifNotNil:[ ^ repo url ].
    cfg := self configurationForPackage: package.
    cfg ifNotNil:
        [^cfg urlForPackage:package].
    ^nil.

    "Modified: / 01-04-2008 / 19:08:35 / janfrog"
    "Created: / 25-05-2009 / 19:48:09 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 16-08-2009 / 16:56:39 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

urlBase:aString 
    |repoConf|

    repoConf := self configurations 
                detect:[:conf | conf packagePattern = '*' ]
                ifNone:[
                    self configurations add:(RepositoryConfiguration new packagePattern:'*')
                ].
    repoConf urlPattern:aString , '/%p'

    "
        SVN::RepositoryManager current urlBase:
            'http://smalltalk.felk.cvut.cz/svn'"

    "Created: / 16-03-2008 / 12:09:21 / janfrog"
    "Modified: / 03-10-2008 / 13:10:03 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

workingCopyBase

    workingCopyBase ifNil:
        [workingCopyBase := (((Filename homeDirectory construct: '.smalltalk')
                                construct: 'working-copy') construct: UUID genUUID printString) asString].
    (Smalltalk packagePath first = workingCopyBase)
        ifFalse:
            [Smalltalk packagePath remove: workingCopyBase ifAbsent:[].
            Smalltalk packagePath addFirst: workingCopyBase].

    ^ workingCopyBase

    "Created: / 16-03-2008 / 12:09:21 / janfrog"
    "Modified: / 10-04-2008 / 13:25:05 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

workingCopyBase:aString
    workingCopyBase := aString.
    self changed:#workingCopyBase

    "Created: / 16-03-2008 / 12:09:21 / janfrog"
    "Modified: / 26-05-2008 / 10:34:27 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!RepositoryManager methodsFor:'accessing - private'!

workingCopyForPackage: package

    ^WorkingCopy new
        path: (self workingCopyBase , '/' , (package asString copy replaceAll:$: with:$/))

    "Created: / 16-03-2008 / 12:09:02 / janfrog"
    "Modified: / 31-03-2008 / 12:58:44 / janfrog"
    "Modified: / 11-04-2008 / 10:48:36 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!RepositoryManager methodsFor:'initialization'!

initialize
    "Invoked when a new instance is created."

    "/ please change as required (and remove this comment)
    "/ baseUrl := nil.
    repositories := Dictionary new.
    Smalltalk addDependent: self.
    Smalltalk addExitBlock:(MessageSend receiver: self selector: #aboutToQuit).

    "/ super initialize.   -- commented since inherited method does nothing

    "Created: / 16-03-2008 / 11:53:21 / janfrog"
    "Modified: / 31-03-2008 / 10:54:28 / janfrog"
    "Modified: / 16-06-2009 / 12:39:26 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reset

    repositories := Dictionary new.

    "Created: / 10-04-2008 / 12:41:00 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

resetConfigurations

    configurations := nil

    "Created: / 25-05-2009 / 18:59:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

resetForPackage: packageId

    repositories removeKey: packageId ifAbsent:[]

    "Created: / 08-04-2009 / 22:37:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!RepositoryManager methodsFor:'queries'!

hasRepositoryForPackage: package

    ^(self repositoryForPackage: package) notNil

    "Created: / 31-03-2008 / 15:11:23 / janfrog"
! !

!RepositoryManager methodsFor:'updating'!

aboutToQuit

    "
     This is send by Smalltalk before the virtual machine
     terminates. If there is no image, removes working copy.
    "

    workingCopyBase isNil ifTrue: [^self].
    workingCopyBase asFilename exists ifFalse:[^self].

    ObjectMemory imageName  
        ifNil:
            ["Windows hack..."
            [workingCopyBase asFilename recursiveRemove]
                on:Smalltalk::Error do:
                    [Delay waitForMilliseconds: 20.
                    [workingCopyBase asFilename recursiveRemove]
                        on:Smalltalk::Error do:
                            [Delay waitForMilliseconds: 40.
                            [workingCopyBase asFilename recursiveRemove]
                                on:Smalltalk::Error do:["nothing"]]]]
        ifNotNil:
            [| imagesStream |
            [imagesStream := (workingCopyBase asFilename / 'images.txt') appendStream.
            imagesStream nextPutLine: ObjectMemory imageName printString]
                ensure:[imagesStream ifNotNil:[imagesStream close]]]

    "Created: / 16-06-2009 / 13:36:21 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 16-07-2009 / 13:54:04 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 22-09-2009 / 15:55:57 / Felix Madrid <fm@exept.de>"
!

class: class renamedFrom: oldName to: newName

    "Created: / 31-03-2008 / 11:06:11 / janfrog"
!

update: aspect with: param from: sender

    (aspect = #classRename)
        ifTrue:[self class: param first renamedFrom: param second to: param first fullName]

    "Created: / 31-03-2008 / 10:54:55 / janfrog"
! !

!RepositoryManager class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
!

version_SVN
    ^'Id: SVN__RepositoryManager.st 110 2009-08-19 13:21:10Z vranyj1 '
! !
